<?php

class BJ_FBPP_Widget extends WP_Widget {

	function BJ_FBPP_Widget() {
		parent::WP_Widget( false, $name = __( 'Popular Posts', 'bj-facebook-popular-posts') );
	}
	
	function widget( $args, $instance ) {
		extract( $args );
		
		$num_posts = intval( $instance['num_posts'] ); 
		if ( ! $num_posts ) {
			$num_posts = 5;
		}

		echo $before_widget;
		echo $before_title . $instance['title'] . $after_title;
		
		$args = array(
			'posts_per_page' => $num_posts,
			'post_type' => 'any',
			'meta_key' => '_bj_fb_shares',
			'orderby' => 'meta_value_num',
			'order' => 'DESC'
		);
		$query = new WP_Query( $args );

		if ( file_exists( ( $tmpl = get_stylesheet_directory() . DIRECTORY_SEPARATOR . 'bj-fbpp-widget.tmpl.php' )) ) { // child theme
			include( $tmpl );
		} elseif ( file_exists( ( $tmpl = get_template_directory() . DIRECTORY_SEPARATOR . 'bj-fbpp-widget.tmpl.php' )) ) { // parent theme
			include( $tmpl );
		} else {
			include( 'bj-fbpp-widget.tmpl.php' );
		}
		
		wp_reset_postdata();
		
		echo $after_widget;
	
	}
	
	function update($new_instance, $old_instance) {
		return $new_instance;
	}
	
	function form( $instance ) {
		?>
		<p>
			<label for="<?php echo $this->get_field_id( 'title' ); ?>">
				<?php _e( 'Title', 'bj-facebook-popular-posts' ); ?>:
				<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $instance['title'] ); ?>" />
			</label>
		</p>
		<p>
			<label for="<?php echo $this->get_field_id('num_posts'); ?>">
				<?php _e( 'Number of posts', 'bj-facebook-popular-posts' ); ?>:
				<input class="widefat" id="<?php echo $this->get_field_id( 'num_posts' ); ?>" name="<?php echo $this->get_field_name( 'num_posts' ); ?>" type="text" value="<?php echo esc_attr( ( intval( $instance['num_posts'] ) ? intval($instance['num_posts']) : 5 ) ); ?>" />
			</label>
		</p>
		<?php
	}
}

add_action( 'widgets_init', create_function('', 'return register_widget("BJ_FBPP_Widget");') );

